%global specversion 1
%global upstream_version 8003b6c

# Keep around for when/if required
%global alphatag %{upstream_version}.git

%global mh_release %{?alphatag:0.}%{specversion}%{?alphatag:.%{alphatag}}%{?dist}

Name:		matahari
Version:	0.4.0
Release:	%{mh_release}.1
Summary:	Matahari QMF Agents for Linux guests

Group:		Applications/System
License:	GPLv2
URL:		http://matahari.fedorahosted.org

# wget --no-check-certificate -O matahari-matahari-{upstream_version}.tgz https://github.com/matahari/matahari/tarball/{upstream_version}
Source0:	matahari-matahari-%{upstream_version}.tgz
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

Requires:	dbus
Requires:	hal
Requires:	qmf > 0.7
Requires:	pcre

BuildRequires:	cmake
BuildRequires:	libudev-devel
BuildRequires:	gcc-c++
BuildRequires:	dbus-devel
BuildRequires:	hal-devel
BuildRequires:	qpid-cpp-server-devel > 0.7
BuildRequires:	qmf-devel > 0.7
BuildRequires:	pcre-devel
BuildRequires:	glib2-devel
BuildRequires:	sigar-devel

%description

Matahari provides QMF Agents that can be used to control and manage
various pieces of functionality, using the AMQP protocol.

The Advanced Message Queuing Protocol (AMQP) is an open standard application
layer protocol providing reliable transport of messages.

QMF provides a modeling framework layer on top of qpid (which implements
AMQP).  This interface allows you to manage a host and its various components
as a set of objects with properties and methods.

%package broker
License:	GPLv2+
Summary:	Optional AMQP Broker for Matahari
Group:		Applications/System
Requires:	%{name} = %{version}-%{release}
Requires:	qpid-cpp-server > 0.7
Requires:	qmf > 0.7

%description broker
Optional AMQP Broker for Matahari

%package devel
License:	GPLv2+
Summary:	Matahari development package
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}
Requires:	qpid-cpp-server-devel > 0.7
Requires:	qmf-devel > 0.7
Requires:	glib2-devel

%description devel
Headers and shared libraries for developing Matahari agents.

%prep
%setup -q -n matahari-matahari-%{upstream_version}

%build
%{cmake} -DCMAKE_BUILD_TYPE=RelWithDebInfo .
make %{?_smp_mflags}

%install
rm -rf %{buildroot}
make DESTDIR=%{buildroot} install

%{__install} -d $RPM_BUILD_ROOT/%{_sysconfdir}/rc.d/init.d
%{__install} matahari.init   $RPM_BUILD_ROOT/%{_sysconfdir}/rc.d/init.d/matahari-net
%{__install} matahari.init   $RPM_BUILD_ROOT/%{_sysconfdir}/rc.d/init.d/matahari-host
%{__install} matahari.init   $RPM_BUILD_ROOT/%{_sysconfdir}/rc.d/init.d/matahari-service
%{__install} matahari-broker $RPM_BUILD_ROOT/%{_sysconfdir}/rc.d/init.d/matahari-broker

%{__install} -d $RPM_BUILD_ROOT/%{_sysconfdir}/sysconfig/
%{__install} matahari.sysconf $RPM_BUILD_ROOT/%{_sysconfdir}/sysconfig/matahari
%{__install} matahari-broker.sysconf $RPM_BUILD_ROOT/%{_sysconfdir}/sysconfig/matahari-broker
%{__ln_s} qpidd $RPM_BUILD_ROOT/%{_sbindir}/matahari-brokerd

%{__install} -d -m0755 %{buildroot}%{_localstatedir}/lib/%{name}
%{__install} -d -m0755 %{buildroot}%{_localstatedir}/run/%{name}

%post
for svc in net host service ; do
    /sbin/chkconfig --level 2345 matahari-$svc on
    /sbin/service matahari-$svc condrestart
done

%post broker
/sbin/chkconfig --level 2345 matahari-broker on
/sbin/service matahari-broker condrestart

%preun
if [ $1 = 0 ]; then
    for svc in net host service ; do
       /sbin/service matahari-$svc stop >/dev/null 2>&1 || :
       chkconfig --del matahari-$svc
    done
fi

%preun broker
if [ $1 = 0 ]; then
    /sbin/service matahari-broker stop >/dev/null 2>&1 || :
    chkconfig --del matahari-broker
fi

%postun
if [ "$1" -ge "1" ]; then
    for svc in net host service ; do
       /sbin/service matahari-$svc condrestart >/dev/null 2>&1 || :
    done
fi

%postun broker
if [ "$1" -ge "1" ]; then
    /sbin/service matahari-broker condrestart >/dev/null 2>&1 || :
fi

%clean
test "x%{buildroot}" != "x" && rm -rf %{buildroot}

%files
%defattr(644, root, root, 755)
%dir %{_datadir}/matahari/
%{_libdir}/libm*.so.*

%config(noreplace) %{_sysconfdir}/sysconfig/matahari

%attr(755, root, root) %{_initddir}/matahari-net
%attr(755, root, root) %{_sbindir}/matahari-netd

%attr(755, root, root) %{_initddir}/matahari-host
%attr(755, root, root) %{_sbindir}/matahari-hostd

%attr(755, root, root) %{_initddir}/matahari-service
%attr(755, root, root) %{_sbindir}/matahari-serviced

%doc AUTHORS COPYING

%files broker
%defattr(644, root, root, 755)
%attr(755, root, root) %{_initddir}/matahari-broker
%config(noreplace) %{_sysconfdir}/sysconfig/matahari-broker
%config(noreplace) %{_sysconfdir}/matahari-broker.conf
%{_sbindir}/matahari-brokerd

%attr(755, qpidd, qpidd) %{_localstatedir}/lib/%{name}
%attr(755, qpidd, qpidd) %{_localstatedir}/run/%{name}

%files devel
%defattr(644, root, root, 755)
%{_datadir}/matahari/schema.xml
%{_includedir}/matahari.h
%{_libdir}/libm*.so

%changelog
* Tue Feb 08 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.4.0-0.1.8003b6c.git.1
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Mon Jan 31 2011 Andrew Beekhof <andrew@beekhof.net> - 0.4.0-0.1.8003b6c.git
- Improved modular agent design
- Cross-platform (see mingw32-matahari)
- Added Networking and Services (supporting LSB and OCF scripts) agents

* Wed Sep 29 2010 jkeating - 0.0.5-4
- Rebuilt for gcc bug 634757

* Mon Sep 20 2010 Tom "spot" Callaway <tcallawa@redhat.com> - 0.0.5-3
- fix header and compiler issues in code which were preventing build

* Mon Aug 16 2010 Darryl L. Pierce <dpierce@redhat.com> - 0.0.5-2
- Rebuild for updated Qpid/WMF.

* Wed Jul  7 2010 Darryl L. Pierce <dpierce@redhat.com> - 0.0.5-1
- Rebuild for updated Qpid/QMF.
- Resolves: rhbz602975 - Matahari messages are not accepted by current version of qpid in F13

* Thu Oct 08 2009 Arjun Roy <arroy@redhat.com> - 0.0.4-7
- Refactored for new version of qpidc.

* Fri Oct 02 2009 Kevin Kofler <Kevin@tigcc.ticalc.org> - 0.0.4-6
- Rebuild for new qpidc.

* Sat Jul 25 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.0.4-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Thu Jul 16 2009 Arjun Roy <arroy@redhat.com> - 0.0.4-4
- Changed buildroot value to meet fedora packaging guidelines
- Updated project website

* Mon Jul 13 2009 Arjun Roy <arroy@redhat.com> - 0.0.4-3
- Quietened rpmlint errors and warnings.
- Fixed most gcc warnings.
- Changed init script so it doesn't run by default
- Now rpm specfile makes it so service runs by default instead

* Thu Jul 9 2009 Arjun Roy <arroy@redhat.com> - 0.0.4-2
- Bumped qpidc and qmf version requirements to 0.5.790661.

* Thu Jul 9 2009 Arjun Roy <arroy@redhat.com> - 0.0.4-1
- Removed dependency on boost. Added dependency on pcre.

* Thu Jul 2 2009 Arjun Roy <arroy@redhat.com> - 0.0.3-2
- Fixed bug with not publishing host hypervisor and arch to broker
- Updated aclocal.m4 to match new version of automake

* Tue Jun 30 2009 Arjun Roy <arroy@redhat.com> - 0.0.3-1
- Added getopt and daemonize support
- Added sysV init script support

* Mon Jun 29 2009 Arjun Roy <arroy@redhat.com> - 0.0.2-1
- Now tracks hypervisor and arch using libvirt

* Tue Jun 23 2009 Arjun Roy <arroy@redhat.com> - 0.0.1-1
- Initial rpmspec packaging
